#================================================================#
# ADVERTS
#================================================================#

import es, os
from etmod_2008.languages.languages import languages
from etmod_2008.logs.logs import log
from etmod_2008.players.players import players
#from etmod_2008.menus.menus import *

#___________________________________________CLASSES

# ------------ #
# CLASSES #
# ------------ #
class Vote:
	def __init__(self, title, avgLevelRequired):
		self.Title = title
		self.AvgLevelRequired = avgLevelRequired
	#def Start(self):
	#	startVote(self)
class ModConfigVote(Vote):
	def __init__(self, title, avgLevelRequired, variable, values):
		Vote.__init__(self, title, avgLevelRequired)
		self.Variable = variable
		self.Values = values
class ClassConfigVote(Vote):
	def __init__(self, title, avgLevelRequired, element, data):
		Vote.__init__(self, title, avgLevelRequired)
		self.Element = element
		self.Data = data		

#___________________________________________DECLARATIONS

# --------------------- #
# DECLARATIONS #
# --------------------- #
votesConfigPath = "cstrike/addons/eventscripts/etmod_2008/votes/configuration"
modConfigVoteOptions = {
	"et_random_classes"					:	{ "level":0, "values":("1","0") },
	"et_use_colors"						:	{ "level":0, "values":("1","0") },
	"et_restrict_classes"				:	{ "level":5, "values":("1","0") },
	"et_restrict_players_in_classes"	:	{ "level":5, "values":("1","0") },
	"et_unlimited_ammo"					:	{ "level":5, "values":("1","0") },
	"et_no_reload"						:	{ "level":5, "values":("1","0") },
	"et_spawn_delay"					:	{ "level":5, "values":("1","2","3","4","5","10","15","20","25","30") },
	"et_spawn_protection_time"			:	{ "level":5, "values":("0","1","2","3","4","5","6","7","8","9","10") },
	"et_synchronized_spawn"				:	{ "level":5, "values":("1","0") },
	"et_bots_level"						:	{ "level":10, "values":("0","1","2","3","4","5","10","15","20","25","30","50","100") },
	"et_hurt_lose_xp"					:	{ "level":15, "values":("1","0") },
	"et_round_xp"						:	{ "level":25, "values":("50","100","150","200","250","300","350","400","450","500","1000") },
	"et_round_money"					:	{ "level":25, "values":("100","200","300","400","500","750","1000","1500","2000","5000") }
}
classElements = ( "parameters", "armory", "prerequisites", "stats", "prices" )
currentVote = None
votesConfigPath = "cstrike/addons/eventscripts/etmod_2008/votes/configuration"

#___________________________________________FUNCTIONS

# ----------------- #
# FUNCTIONS #
# ----------------- #
''' Start a vote '''
#def startVote(vote):
#	currentVote = vote
#	for p in players.values():
#		if p.Stats.GetAverageLevel() >= vote.AvgLevelRequired:
#			showMenuCurrentVote(p.ID)
			
def loadVotesConfig():
	f = None
	try:
		curPath = os.path.join(os.getcwd(), os.path.join(votesConfigPath, "votes.cfg"))
		
		f = open(curPath, "r")
		block = None
		for line in f:
			# Skip commented lines
			if line.startswith("//"):
				continue
				
			# Split based on quotes
			parts = str.split(line, "\"")
			
			# 3 parts = block name
			if len(parts) == 3:
				log("Votes block: " + parts[1])
				block = parts[1]
				
			# 5 parts = vote property
			elif len(parts) == 5 and block is not None:
				var = parts[1]
				val = parts[3].strip("\n")
				val = val.strip("\r")
				log("Block: " + str(block) + " - Vote info: " + str(var) + " - Value: " + str(val))
				
				# Mod config
				if block == "mod":
					# Replace in current config if the key exists
					if modConfigVoteOptions.has_key(var):
						try: modConfigVoteOptions[var]["level"] = int(val)
						except: log("Skipped value " + str(val) + " for variable " + str(var) + " for mod config")
				
		log("Votes config loaded")
	except:
		log("Error while trying to load votes config file")
	finally:
		if f is not None:
			f.close()
			
#___________________________________________SERVER EVENTS

# --------------------- #
# SERVER EVENTS #
# --------------------- #
''' Script loaded '''
def load():
	# Load config
	loadVotesConfig()
	
	# Log
	log("Votes sub-script loaded")	
''' Script unloaded '''
def unload():
#	votes.Save()
	
	# Log
	log("Votes sub-script unloaded")